<template>
  <div id="carouselExampleIndicators" class="carousel slide" data-bs-ride="carousel">

    <div class="carousel-inner">
      <div class="carousel-item" v-for="(image, index) in images"
             :key="image"
             :class="{ active: index===show}">
          <button @click="previous(index)" class="carousel-control-prev" type="button" data-bs-target="#carouselExampleIndicators" data-bs-slide="prev">
            <span class="carousel-control-prev-icon" aria-hidden="true"></span>
            <span class="visually-hidden">Previous</span>
          </button>
          <button @click="next(index)" class="carousel-control-next" type="button" data-bs-target="#carouselExampleIndicators" data-bs-slide="next">
            <span class="carousel-control-next-icon" aria-hidden="true"></span>
            <span class="visually-hidden">Next</span>
          </button>
        <img :src="require('../assets/' + image)" :key="index" alt="Carousel image of food" class="d-block w-100">
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "Carousel",
  data() {
    return {
      show: 0
    }
  },
  props: {
    images: {
      type: Array
    }
  },
  created() {
    setInterval( () => {
      this.next(this.show);
    }, 4000)
  },
  methods: {
    previous(index) {
      let calculated_index = index - 1
      if (calculated_index < 0) {
        this.show = this.images.length - 1
      } else {
        this.show = calculated_index
      }
    },
    next(index) {
      let calculated_index = index + 1
      if (calculated_index > this.images.length - 1) {
        this.show = 0
      } else {
        this.show = calculated_index
      }
    },
    auto() {
      setTimeout( () => {
        this.next(this.show)
      }, 2000)
    }
  }
}
</script>

<style scoped>
.carousel.slide {
  max-width: 50rem;
  margin: 2rem auto;
}
</style>